[Lenovo Legion7 16ACHg6 82N6, Realtek ALC287, Speaker, Internal] No sound at all

Bug #1958019 reported by 3DRaven
26
This bug affects 4 people
Affects Status Importance Assigned to Milestone
sound-2.6 (alsa-kernel)
Confirmed
Medium
alsa-driver (Ubuntu)
Confirmed
Undecided
Unassigned

Bug Description

On my Lenovo Legion-7-16ACHg6 laptop I can't hear any sound by internal speakers, but it work by headphones connected to standard jack aux.

uname -r
5.11.0-44-generic

ProblemType: Bug
DistroRelease: Ubuntu 20.04
Package: alsa-base 1.0.25+dfsg-0ubuntu5
ProcVersionSignature: Ubuntu 5.11.0-44.48~20.04.2-generic 5.11.22
Uname: Linux 5.11.0-44-generic x86_64
NonfreeKernelModules: nvidia_modeset nvidia
ApportVersion: 2.20.11-0ubuntu27.21
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC2: i3draven 1266 F.... pulseaudio
 /dev/snd/controlC0: i3draven 1266 F.... pulseaudio
 /dev/snd/controlC1: i3draven 1266 F.... pulseaudio
 /dev/snd/pcmC1D0p: i3draven 1266 F...m pulseaudio
CasperMD5CheckResult: skip
CurrentDesktop: ubuntu:GNOME
Date: Sat Jan 15 15:10:53 2022
InstallationDate: Installed on 2021-10-11 (96 days ago)
InstallationMedia: Ubuntu 20.04.3 LTS "Focal Fossa" - Release amd64 (20210819)
PackageArchitecture: all
SourcePackage: alsa-driver
Symptom: audio
Symptom_AlsaPlaybackTest: ALSA playback test through plughw:Generic failed
Symptom_Card: Family 17h (Models 10h-1fh) HD Audio Controller - HD-Audio Generic
Symptom_DevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC2: i3draven 1266 F.... pulseaudio
 /dev/snd/controlC0: i3draven 1266 F.... pulseaudio
 /dev/snd/controlC1: i3draven 1266 F.... pulseaudio
 /dev/snd/pcmC1D0p: i3draven 1266 F...m pulseaudio
Symptom_Jack: Speaker, Internal
Symptom_Type: No sound at all
Title: [82N6, Realtek ALC287, Speaker, Internal] No sound at all
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 11/08/2021
dmi.bios.release: 1.49
dmi.bios.vendor: LENOVO
dmi.bios.version: GKCN49WW
dmi.board.asset.tag: NO Asset Tag
dmi.board.name: LNVNB161216
dmi.board.vendor: LENOVO
dmi.board.version: SDK0R32862 WIN
dmi.chassis.asset.tag: NO Asset Tag
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Legion 7 16ACHg6
dmi.ec.firmware.release: 1.49
dmi.modalias: dmi:bvnLENOVO:bvrGKCN49WW:bd11/08/2021:br1.49:efr1.49:svnLENOVO:pn82N6:pvrLegion716ACHg6:skuLENOVO_MT_82N6_BU_idea_FM_Legion716ACHg6:rvnLENOVO:rnLNVNB161216:rvrSDK0R32862WIN:cvnLENOVO:ct10:cvrLegion716ACHg6:
dmi.product.family: Legion 7 16ACHg6
dmi.product.name: 82N6
dmi.product.sku: LENOVO_MT_82N6_BU_idea_FM_Legion 7 16ACHg6
dmi.product.version: Legion 7 16ACHg6
dmi.sys.vendor: LENOVO

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

I get no sound via the speakers of my Lenovo Legion 7i laptop, which alsamixer tells me is using a Realtek ALC287.

I have tried various Linux distros and kernel combinations, including Ubuntu 16.04, 18.04, and 20.04, with both the default and mainline kernels (5.7.x & 5.8.x), and Manjaro with 5.6.x, 5.7.x and 5.8.x kernels.

In each case, I made sure to disable Auto-Mute in alsamixer, and turn all volume levels to maximum. In all cases, I get no sounds from the speakers (running speaker-test, playing music, etc.). I *am* able to get sound via headphones and HDMI (though I believe HDMI is via a different sound card).

Also, I can see that there is some kind of sound activity occurring when I look at pavucontrol (the reddish-orange bar that indicates a sound is playing), but there is no actual sound produced from the speakers.

My alsa-info.sh results (from Manjaro on 5.6.15) are here:

http://alsa-project.org/db/?f=ba86fe76a9d9cf1cced56600edf82eb206a36a72

I am happy to run the script again (or any other tool) from a different distro/kernel combination, please just let me know what would be helpful.

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

Update using more recent kernel:

http://alsa-project.org/db/?f=4272343a3590cc08f192f98113dedfc0418afe52

In order to provide better information, I have run alsa-info.sh from Ubuntu 20.04 running the latest mainline kernel 5.7.9-050709-generic. I have also updated the "Kernel Version" field in this bug report to reflect this.

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

I also tried with kernel 5.8.0-050800rc5-generic. Same result, no sound via speakers.

Revision history for this message
In , knotted10 (knotted10-linux-kernel-bugs) wrote :

I can confirm, same thing is happening to me, using manjaro with kernel 5.6.19-2-MANJARO

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Can confirm here with Kubuntu 20.04 with kernel 5.4.0-40-generic and kernel 5.7.14... Sound works through head phones (using either bluetooth or a analog 3.5 mm cable). I did notice that playback via bluetooth stopped once... After putting the laptop to sleep then waking it back up, audio via bluetooth resumed.

I do not know if I am able to get audio via HDMI, I'm unsure how to use that setting (or is an external HDMI monitor needed for that?).

Revision history for this message
In , n0.b741n37+bugzilla.kernel (n0.b741n37+bugzilla.kernel-linux-kernel-bugs) wrote :

+1 for this on Manjaro with kernel 5.7.14.

Revision history for this message
In , contact (contact-linux-kernel-bugs) wrote :

Same issue.
I tested Manjaro with kernel 5.8.4.
Also tested Mint 20 with kernel 5.4.0-42, Ubuntu 20.04, Fedora 32 and PopOS.
Working with 3.5mm audio jack, bluetooth and docking station on USB-C.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Is everyone experiencing this on machines other than the Lenovo Legion 7i? Or is everyone on this same machine so far?

Revision history for this message
In , contact (contact-linux-kernel-bugs) wrote :

Forgot to mentioned it, Legion 7i for me.

Revision history for this message
In , vince.tavernier (vince.tavernier-linux-kernel-bugs) wrote :

Experiencing this issue (no sound on speakers, but headphones and other outputs work fine) on a Legion 7i too on my side, on Fedora 32, kernel 5.8.4-200.fc32.x86_64.

Revision history for this message
In , sentinum (sentinum-linux-kernel-bugs) wrote :

I have the exact same issue on Linux version 5.4.0-47-generic (buildd@lcy01-amd64-014) (gcc version 9.3.0 (Ubuntu 9.3.0-10ubuntu2)), with Lenovo Legion 7 81YT. I tried the same things as everybody else and could not get these speakers to work. I am a bit confused because some specs I found online for the the Legion 7 mention ALC 3306 -https://psref.lenovo.com/syspool/Sys/PDF/Legion/Lenovo_Legion_7_15IMHg05/Lenovo_Legion_7_15IMHg05_Spec.pdf (could not find any driver related to it) Vs ALC 287 identified by alsamixer. Speakers work just fine on Windows 10.

Revision history for this message
In , kernel.org (kernel.org-linux-kernel-bugs) wrote :

(In reply to Cameron from comment #7)
> Is everyone experiencing this on machines other than the Lenovo Legion 7i?
> Or is everyone on this same machine so far?

My issues are also present on Legion 7i (Legion 7-15IMH05 Type 81YT).

Here is my alsa-info: http://alsa-project.org/db/?f=f74d2b20683de3bc0daab8c4740f34a66955ba70

A notable thing is that i *DID* have speaker audio for a couple of weeks (headphones have always worked), until it suddenly stopped working again. My guess is that there might have been regression due to some package being updated but I could not find any meaningful culprit.

I can paste the hidden BIOS HD audio settings for this configuration if that's of any use.

Kernel is 5.4.0-47-generic #51-Ubuntu SMP Fri Sep 4 19:50:52 UTC 2020 x86_64 x86_64 x86_64 GNU/Linux

Distributor ID: Ubuntu
Description: Ubuntu 20.04.1 LTS

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

(In reply to kernel.org from comment #11)
> (In reply to Cameron from comment #7)
> > Is everyone experiencing this on machines other than the Lenovo Legion 7i?
> > Or is everyone on this same machine so far?
>
> My issues are also present on Legion 7i (Legion 7-15IMH05 Type 81YT).
>
> Here is my alsa-info:
> http://alsa-project.org/db/?f=f74d2b20683de3bc0daab8c4740f34a66955ba70
>
> A notable thing is that i *DID* have speaker audio for a couple of weeks
> (headphones have always worked), until it suddenly stopped working again.
> My guess is that there might have been regression due to some package being
> updated but I could not find any meaningful culprit.
>
> I can paste the hidden BIOS HD audio settings for this configuration if
> that's of any use.
>
> Kernel is 5.4.0-47-generic #51-Ubuntu SMP Fri Sep 4 19:50:52 UTC 2020 x86_64
> x86_64 x86_64 GNU/Linux
>
> Distributor ID: Ubuntu
> Description: Ubuntu 20.04.1 LTS

Do you have any details for the time period that you did have sound? Was it a fresh install of Ubuntu 20.04.1? Did you allow internet updates during install? If you still have the ISO you used, I'd also like to confirm the hash of the file. If we can reproduce it, we'll be a lot closer to a solution.

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

Also, regarding the advanced BIOS settings, there are several sound modes you switch the laptop into.

I tried a few but didn't get anything to work. I'm not very knowledgeable in this area though.

Accessing advanced BIOS is documented here:

>Advanced BIOS options can be accessed by going into more settings, hold down
>Fn and press each key horizontally from q to p, a to l, then z to m, let go of
>Fn and press F10. Click save changes and reboot into BIOS. Advanced settings
>will now be available.

https://wiki.archlinux.org/index.php/Lenovo_Legion_7i

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

For convenience, here's how to navigate to the audio settings under the advanced BIOS settings:
Advanced -> PCH-IO -> HD Audio Configuration

I going to attach pictures showing the top level Audio menu. There's quite a bit more settings under the sub-menus though.

It's worth mentioning that in my experience that many settings available under the advance BIOS settings do not seem to work. I haven't tried any of the audio settings yet (and there are quite a few), but in general many settings probably only apply to certain models of laptop aside from the Legion 7i. Presumably at least some of the audio settings should work though.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Created attachment 292497
Top half of top level audio level

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Created attachment 292499
bottom half of the top level audio menu

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

About how long have you had your Legion? I've had mine since August 6th IIRC, and I've always had this problem. Could help narrow down the window.

Could this be possibly related to a BIOS update?

> A notable thing is that i *DID* have speaker audio for a couple of weeks
> (headphones have always worked), until it suddenly stopped working again.
> My guess is that there might have been regression due to some package being
> updated but I could not find any meaningful culprit.

Revision history for this message
In , kernel.org (kernel.org-linux-kernel-bugs) wrote :

(In reply to Cameron from comment #17)
> About how long have you had your Legion? I've had mine since August 6th
> IIRC, and I've always had this problem. Could help narrow down the window.
>
> Could this be possibly related to a BIOS update?
>
> > A notable thing is that i *DID* have speaker audio for a couple of weeks
> > (headphones have always worked), until it suddenly stopped working again.
> > My guess is that there might have been regression due to some package being
> > updated but I could not find any meaningful culprit.

I got mine in the beginning of August. Updated immediately to 2.02 BIOS.

I had already prepared for not having sound as I had read the Arch Wiki page, and was really struck with a surprise as one day after playing with merely the ubuntu sound settings (fiddling with system sound volume) the speakers suddenly started working. I did not make any notes of the occasion as I assumed there might have been a recent kernel or some other package update, and did not expect any regressions to occur. But they did a couple of weeks later and that's when I found this ticket for ALC287.

What makes tracking this down a bit trickier than just booting with earlier kernel packages is that I have fiddled with both alsa and pulse on the system (e.g. tried different kernel module options for snd-hda-intel) so my working state was never a vanilla install with some updates. I will nevertheless try to get back to a working configuration with some kernel and report back.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

I immediately upgraded to 2.02 as well... But tried reverting to the previous version (2.01 probably?) to test something unrelated. That didn't fix my issues.

Anyway, might be worth looking at /var/log/dpkg.log* to see what had been installed/updated around that time frame. I've skimmed through and so far the only thing that stands out are some pulse audio updates on July 23rd. So unless you don't update frequently, that's probably not it.

> What makes tracking this down a bit trickier than just booting with earlier
> kernel packages is that I have fiddled with both alsa and pulse on the
> system (e.g. tried different kernel module options for snd-hda-intel) so my
> working state was never a vanilla install with some updates. I will
> nevertheless try to get back to a working configuration with some kernel and
> report back.

Revision history for this message
In , ealex95 (ealex95-linux-kernel-bugs) wrote :

I'm having the same issue on a Lenovo Legion 7-15IMHg05. I just got it this week (22nd september) and installed Arch Linux on it straight away. I tried fiddling with alsamixer and pavucontrol settings, no change. I tried different kernel packages (linux 5.8.10, linux-lts 5.4.66, linux-xanmod 5.8.10/11), no dice. I did not update the BIOS yet and the current version is "E9CN32WW(V2.00)", so this probably rules out a BIOS regression.

My alsa-info: http://alsa-project.org/db/?f=60beb004225ca38c49bb6a1495e6cd713a1a4f1e

I did not test the laptop with Windows yet, but I will try to do this soon.

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

Perhaps there is a way to force ALSA to recognize the card as an ALC3306. As Fab mentioned, the specs do seem to indicate that as the sound device.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Did you find this in the documentation? I haven't found any references
to ALC3306 on my system

Doing a quick search for ALC3306, the only references that come up are
for the Lenovo Legion 7 and the Yoga Slim 7.  The ALC3306 seems to be
pretty uncommon and pretty new.

Doing a bit of research, sounds like audio works on the Yoga Slim 7.
Possibly a red herring..?

On 9/25/20 7:38 PM, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> --- Comment #21 from <email address hidden> ---
> Perhaps there is a way to force ALSA to recognize the card as an ALC3306. As
> Fab mentioned, the specs do seem to indicate that as the sound device.
>

Revision history for this message
In , pyronavi (pyronavi-linux-kernel-bugs) wrote :

(In reply to Cameron from comment #22)
> Did you find this in the documentation? I haven't found any references
> to ALC3306 on my system
>
> Doing a quick search for ALC3306, the only references that come up are
> for the Lenovo Legion 7 and the Yoga Slim 7.  The ALC3306 seems to be
> pretty uncommon and pretty new.
>
> Doing a bit of research, sounds like audio works on the Yoga Slim 7.
> Possibly a red herring..?
>
> On 9/25/20 7:38 PM, <email address hidden> wrote:
> > https://bugzilla.kernel.org/show_bug.cgi?id=208555
> >
> > --- Comment #21 from <email address hidden> ---
> > Perhaps there is a way to force ALSA to recognize the card as an ALC3306.
> As
> > Fab mentioned, the specs do seem to indicate that as the sound device.
> >

My mistake. I must have seen "Legion 7" and mistaken it for the 7i.

Also, I have just sent an email to the members of the ALSA team. Hopefully someone will reply soon.

Revision history for this message
In , ealex95 (ealex95-linux-kernel-bugs) wrote :

> I did not test the laptop with Windows yet, but I will try to do this soon.

Tested now, it works fine on Windows. I also updated the bios to E9CN58WW(V4.03), still doesn't work on Linux.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

I think the 7 and 7i are the same. In the case of the Legion 5/5i, the i
differentiates between the AMD and Intel versions. However, I believe
there's still no plans to make an AMD version of the Legion 7.

My point was that sound seems to work on the Yoga 7 under Linux, which
also has the ALC3306 so maybe it's not related to the ALC3306 codec.

On 9/26/2020 7:43 AM, <email address hidden> wrote:
> My mistake. I must have seen "Legion 7" and mistaken it for the 7i.

Revision history for this message
In , erkanadali91 (erkanadali91-linux-kernel-bugs) wrote :

I am having same issue with Lenovo Legion 7. Another friend that use the same laptop also having that problem too. I hope they can fix this issue.

Revision history for this message
In , fodor18zoltan (fodor18zoltan-linux-kernel-bugs) wrote :

I am also facing same issue on Ubuntu 20.04 with Legion 7i. Never worked on Linux.

Alsa info http://alsa-project.org/db/?f=286348226d62d73c2aa3987794adfde7ef78095e
Linux archy-Lenovo-Legion-7-15IMHg05 5.9.2-050902-generic #202010290646 SMP Thu Oct 29 11:11:09 UTC 2020 x86_64 x86_64 x86_64 GNU/Linux

38 comments hidden view all 800 comments
Revision history for this message
3DRaven (3draven) wrote :
Revision history for this message
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in alsa-driver (Ubuntu):
status: New → Confirmed
Revision history for this message
Przemek K. (azrael) wrote (last edit ):

I have the same issue.
I have a Legion 7 16ACHg6 (82N6007CPB) which I'm testing under Ubuntu 20.04.3 LTS and 21.10 LiveUSB, and in both of them there is no sound out of the built-in speakers. Headphones are working fine though.
05:00.6 Audio device: Advanced Micro Devices, Inc. [AMD] Family 17h (Models 10h-1fh) HD Audio Controller
hwinfo shows that there is a "Realtek ALC701" chip in this laptop.
Full hwinfo output attached.

Revision history for this message
Przemek K. (azrael) wrote :
summary: - [82N6, Realtek ALC287, Speaker, Internal] No sound at all
+ [Lenovo Legion7 82N6, Realtek ALC287, Speaker, Internal] No sound at all
summary: - [Lenovo Legion7 82N6, Realtek ALC287, Speaker, Internal] No sound at all
+ [Lenovo Legion7 16ACHg6 82N6, Realtek ALC287, Speaker, Internal] No
+ sound at all
Revision history for this message
Przemek K. (azrael) wrote :
Revision history for this message
Przemek K. (azrael) wrote :

Alsa-info output saved to a file

tags: added: apport-collected impish
Revision history for this message
Przemek K. (azrael) wrote : apport information

ProblemType: Bug
ApportVersion: 2.20.11-0ubuntu70
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC1: ubuntu 5091 F.... pulseaudio
 /dev/snd/pcmC1D0p: ubuntu 5091 F...m pulseaudio
 /dev/snd/controlC0: ubuntu 5091 F.... pulseaudio
CasperMD5CheckResult: pass
CasperVersion: 1.465
CurrentDesktop: ubuntu:GNOME
DistroRelease: Ubuntu 21.10
LiveMediaBuild: Ubuntu 21.10 "Impish Indri" - Release amd64 (20211012)
NonfreeKernelModules: zfs zunicode zavl icp zcommon znvpair
Package: alsa-driver (not installed)
ProcEnviron:
 TERM=xterm-256color
 PATH=(custom, no user)
 XDG_RUNTIME_DIR=<set>
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 5.13.0-19.19-generic 5.13.14
Tags: impish
Uname: Linux 5.13.0-19-generic x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups: adm cdrom dip lpadmin lxd plugdev sambashare sudo
_MarkForUpload: True
dmi.bios.date: 11/08/2021
dmi.bios.release: 1.49
dmi.bios.vendor: LENOVO
dmi.bios.version: GKCN49WW
dmi.board.asset.tag: NO Asset Tag
dmi.board.name: LNVNB161216
dmi.board.vendor: LENOVO
dmi.board.version: SDK0R32862 WIN
dmi.chassis.asset.tag: NO Asset Tag
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Legion 7 16ACHg6
dmi.ec.firmware.release: 1.49
dmi.modalias: dmi:bvnLENOVO:bvrGKCN49WW:bd11/08/2021:br1.49:efr1.49:svnLENOVO:pn82N6:pvrLegion716ACHg6:skuLENOVO_MT_82N6_BU_idea_FM_Legion716ACHg6:rvnLENOVO:rnLNVNB161216:rvrSDK0R32862WIN:cvnLENOVO:ct10:cvrLegion716ACHg6:
dmi.product.family: Legion 7 16ACHg6
dmi.product.name: 82N6
dmi.product.sku: LENOVO_MT_82N6_BU_idea_FM_Legion 7 16ACHg6
dmi.product.version: Legion 7 16ACHg6
dmi.sys.vendor: LENOVO

Revision history for this message
Przemek K. (azrael) wrote : AlsaInfo.txt

apport information

Revision history for this message
Przemek K. (azrael) wrote : CurrentDmesg.txt

apport information

Revision history for this message
Przemek K. (azrael) wrote : PaInfo.txt

apport information

Revision history for this message
Przemek K. (azrael) wrote : ProcCpuinfoMinimal.txt

apport information

Revision history for this message
Przemek K. (azrael) wrote : PulseList.txt

apport information

Changed in sound-2.6:
importance: Unknown → Medium
status: Unknown → Confirmed
748 comments hidden view all 800 comments
Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

The name doesn't matter, just the numeric ID. If I had a patch worth
submitting, I would fix the names but otherwise they don't matter.

Please share the following outputs with me:
uname -a

And mostly I need this:
dmesg | egrep -i '(csc3551|cs35l41|reset_gpio|short|adev|speaker)'

On 2/28/23 23:47, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> --- Comment #745 from Pierre Hébert (<email address hidden>) ---
> Yes, I confirm that the patch includes the slim 7 in the list of fixups, with
> the right "16IAH7" model number and right numeric id: 0x17aa:0x3803 (same as
> my
> alsa-info), so I thought there was some success for this computer. But
> rewinding the discussion to the top in this thread and the other one
> (https://bugzilla.kernel.org/show_bug.cgi?id=216194) doesn't show any
> evidence
> of success for the "slim" variant. Or maybe I missed it?
> I noticed that the clear text name for the entry in the patch is named
> "Legion
> 7" not "Legion S7". Maybe there's some mismatch here? I mean: could the slim
> references have been used in place of another model, maybe another 7 variant?
> Lenovo's naming scheme is confusing: there's the 7, the 7i, the 7 Pro and the
> S7 which is either named S7 (without "i" no matter Intel or AMD) or Slim 7
> (only AMD) or Slim 7i (only Intel).
>
> I understand the issue with DSD and why it's frustrating. This isn't by far
> the
> first frustration I get with this kind of issue... But fortunately these
> little
> issues are more than balanced by the benefits of running Linux :-)
>
> Using 6.2.1 on my slim 7i (16IAH7), the cs35l41 driver fails to load. If my
> understanding is correct, this will prevent code in the patch to be executed,
> even if some code paths in cs35l41 are bypassed by the patch, right? Please
> correct me if I'm wrong, as really I'm a newbie in this area.
>
> I'm 100% sure that the patch is applied though, but I don't see the related
> printk in the kernel log (in particular there is no "CSC3551: probing"). What
> I
> am trying to understand is whether this is because of the cs35l41 error, and
> in
> which case I should look into this issue first, or whether this is due to
> another problem.
>
> While unloading and reloading cs35l41 modules (snd_hda_scodec_cs35l41_i2c
> snd_hda_scodec_cs35l41_spi snd_hda_scodec_cs35l41 snd_soc_cs35l41_lib
> snd_hda_cs_dsp_ctls cs_dsp), there's no indication of the driver being
> initialized again in kernel logs, so my guess is that this is triggered by
> another sound module. Would you have any hint on a what should be done to
> unload/reload the sound subsystem and avoid reboot between each code
> modification/build?
>
> Thank you so far for the help and the patches. Even if I cannot ever hear
> sound
> from the speakers (and I can perfectly live with this), your work is really
> appreciated!
>
>
> (In reply to Cameron Berkenpas from comment #742)
>> You have the slim? I don't think I added slim support to the patch. I think
>> someone else did and it worked.
>>
>> It's not that hard to do. The numeric ID you need can be found in your
>> alsa-info.

Revision history for this message
In , toggiworks (toggiworks-linux-kernel-bugs) wrote :

Hello Cameron.
Do you think this patch for Slim 7 AMD versions be viable for Yoga Slim 7 Carbon 14ACN6 as well?

Subsystem Id: 0x17aa3856
http://alsa-project.org/db/?f=256bbaf062611cf8f537a377104273142f99d2f1
https://psref.lenovo.com/Detail/Yoga/Yoga_Slim_7_Carbon_14ACN6?M=82L0005RMX

Revision history for this message
In , jmaximusix (jmaximusix-linux-kernel-bugs) wrote :

(In reply to Pierre Hébert from comment #741)
> I'm not too sure that this worked for the slim variant of the legion 7 gen
> 7, or at least jmaximusix, who uses a slim 7 too, doesn't seem to have it
> working neither (https://bugzilla.kernel.org/show_bug.cgi?id=216194#c49).
> Also I get the very same error message regarding CSC3551 (where the serial
> multi-instanciate driver fails to get an irq in smi_i2c_probe).
>
> I applied lenovo-7i-gen7-sound-6.2.0-rc3-0.0.4.patch and I have no doubt
> that the path is active in the currently running kernel. Unfortunately this
> is the only thing I know for sure, I'm sorry to be quite ignorant in most
> other areas regarding sound and amplifiers in Linux :-/

Yes exactly, I have the same laptop and the same issue. If you find any solution, be sure to let me know, and so will I! :D
I think I might be able to clear up some confusion around a patch existing or not. Cameron Berkenpas did try to add support for the Slim 7i using some logs I provided, but that didn't turn out fixing the csc3551 error. So thats why, I think, in his patch, the Slim 7i model (16IAH7) is listed, but it's not working, at least I am unaware of any success anybody had with it.

I have more or less given up on this for now, because at least with my (nonexistent) knowledge of this stuff, I don't see anything in my power I can do. But if anybody has ideas what to try or where to look, I'll happily try it out.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

See https://bugzilla.kernel.org/show_bug.cgi?id=216194 for a new patch. Currently the latest is lenovo-7i-gen7-sound-6.2.0-rc3-0.0.5b-002.patch

This latest patch theoretically has support for Blake Lee's machine.

A new revision of the 16IAX7.

oppsig's Yoga Slim 7 Carbon 14ACN6

Pierre Hébert,

I missed that you were getting this error previous: "Serial bus multi instantiate pseudo device driver CSC3551:00: error -ENOENT: Error requesting irq at index 0"

That is indeed occurring before any of my code. Some hopefully good news is that this is a Cirrus Logic issue that they might fix if you can report it to them. Once fixed, you'd probably still need a patch such as mine to get you over the finish line.

PLEASE READ MY COMMENT HERE AS THIS PATCH IS USE AT-YOUR-OWN-RISK:
https://bugzilla.kernel.org/show_bug.cgi?id=216194#c66

From here on out, I will direct people to bug https://bugzilla.kernel.org/show_bug.cgi?id=216194 as there's far too many posts in this thread and it's made things difficult to keep track of.

Revision history for this message
In , pierrox (pierrox-linux-kernel-bugs) wrote :

(In reply to Cameron Berkenpas from comment #746)

> Please share the following outputs with me:
> uname -a

Linux shin 6.2.1-arch1-1-custom #1 SMP PREEMPT_DYNAMIC Tue, 28 Feb 2023 09:19:31 +0000 x86_64 GNU/Linux

> And mostly I need this:
> dmesg | egrep -i '(csc3551|cs35l41|reset_gpio|short|adev|speaker)'

[ 8.047665] Serial bus multi instantiate pseudo device driver CSC3551:00: error -ENOENT: Error requesting irq at index 0
[ 8.052566] Serial bus multi instantiate pseudo device driver: probe of CSC3551:00 failed with error -2
[ 8.331024] input: PC Speaker as /devices/platform/pcspkr/input/input5
[ 11.421129] snd_hda_codec_realtek ehdaudio0D0: autoconfig for ALC287: line_outs=1 (0x17/0x0/0x0/0x0/0x0) type:speaker
[ 11.421138] snd_hda_codec_realtek ehdaudio0D0: speaker_outs=0 (0x0/0x0/0x0/0x0/0x0)

I'll ask Cirrus developers about the issue.

Agreed, this thread is too long.

Revision history for this message
In , toggiworks (toggiworks-linux-kernel-bugs) wrote :

Hey Cameron, I did apply the patch against kernel 6.2.2 for the 14ACN6.
There was sound from the 2 tweeters as before the patch was applied but still I don't know if the 2 woofers are actually active?
Not sure what the best way to find out if woofers are working.
Is there anything I can do with speaker-test?
But I'll try to compare before and after patch.

I was going to try to sniff the verbs for this laptop but the problem is that the audio controllers are on the same IOMMU groups as radeon gpu, pci, usb and psp.
So I cannot not passthrough the audio devices without ACL override.

Uname -a
Linux 6.2.2-273-tkg-cfs #1 SMP PREEMPT_DYNAMIC TKG Sat, 04 Mar 2023 08:30:30 +0000 x86_64 GNU/Linux

Alsa info:
http://alsa-project.org/db/?f=f1d466ea0cfa556f461b73a529bba4a66d634725

Dmesg:
❯ sudo dmesg | grep -E '(csc3551|cs35l41|reset_gpio|short|adev|speaker)'
[ 0.654315] IPI shorthand broadcast: enabled
[ 19.026160] snd_hda_codec_realtek hdaudioC1D0: autoconfig for ALC287: line_outs=1 (0x14/0x0/0x0/0x0/0x0) type:speaker
[ 19.026199] snd_hda_codec_realtek hdaudioC1D0: speaker_outs=0 (0x0/0x0/0x0/0x0/0x0)
[ 23.866865] wlan0: VHT capa missing/short, disabling VHT/HE/EHT
[ 200.121348] wlan0: VHT capa missing/short, disabling VHT/HE/EHT
[ 271.290659] wlan0: VHT capa missing/short, disabling VHT/HE/EHT

bugid for this laptop:
https://bugzilla.kernel.org/show_bug.cgi?id=215632

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Looking more closely at your alsa-info... You have:
/sys/bus/acpi/devices/CLSA0102:00/status

I didn't even know the CLSA0102 existed! Just the CLSA0100 and the
CLSA0101. I don't think that's supported at all at this point. You might
try reaching out to Cirrus Logic. I think that's your best bet. There's
certainly nothing I can do. Sounds like the CLSA0102 's are strictly for
your the woofers?

CLSA0102 is almost certainly going to fall under cs35l41 and like the
CLSA010/1, it would likely need a custom code path.

Really wish Lenovo would play more nice with us. Yes, they have Linux
specific offerings, but like most of you, I'm not interested in those.
And in case anyone from Lenovo is listening... I'm not personally
interested in getting ANY Lenovo support for Linux. I just want my
hardware to work.

On 3/4/23 03:39, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> --- Comment #751 from oppsig (<email address hidden>) ---
> Hey Cameron, I did apply the patch against kernel 6.2.2 for the 14ACN6.
> There was sound from the 2 tweeters as before the patch was applied but still
> I
> don't know if the 2 woofers are actually active?
> Not sure what the best way to find out if woofers are working.
> Is there anything I can do with speaker-test?
> But I'll try to compare before and after patch.
>
> I was going to try to sniff the verbs for this laptop but the problem is that
> the audio controllers are on the same IOMMU groups as radeon gpu, pci, usb
> and
> psp.
> So I cannot not passthrough the audio devices without ACL override.
>
> Uname -a
> Linux 6.2.2-273-tkg-cfs #1 SMP PREEMPT_DYNAMIC TKG Sat, 04 Mar 2023 08:30:30
> +0000 x86_64 GNU/Linux
>
> Alsa info:
> http://alsa-project.org/db/?f=f1d466ea0cfa556f461b73a529bba4a66d634725
>
> Dmesg:
> ❯ sudo dmesg | grep -E '(csc3551|cs35l41|reset_gpio|short|adev|speaker)'
> [ 0.654315] IPI shorthand broadcast: enabled
> [ 19.026160] snd_hda_codec_realtek hdaudioC1D0: autoconfig for ALC287:
> line_outs=1 (0x14/0x0/0x0/0x0/0x0) type:speaker
> [ 19.026199] snd_hda_codec_realtek hdaudioC1D0: speaker_outs=0
> (0x0/0x0/0x0/0x0/0x0)
> [ 23.866865] wlan0: VHT capa missing/short, disabling VHT/HE/EHT
> [ 200.121348] wlan0: VHT capa missing/short, disabling VHT/HE/EHT
> [ 271.290659] wlan0: VHT capa missing/short, disabling VHT/HE/EHT
>
> bugid for this laptop:
> https://bugzilla.kernel.org/show_bug.cgi?id=215632
>

Revision history for this message
In , hyc (hyc-linux-kernel-bugs) wrote :

Hey again, sorry I just now noticed this: on my 2021 Legion 7 16ACHg6, the sound from the left speaker is much quieter than from the right speaker. Is there anything I can tweak to adjust this?

Revision history for this message
In , hyc (hyc-linux-kernel-bugs) wrote :

One last note - playing a particular video clip (Star Trek Strange New Worlds S01E10), the opening splash sequence, the maximum loudness in Linux was only 65dB, and 78dB in Windows. Volume control set to 100% in both cases, identical video file.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Here's a thread where people are expressing their dissatisfaction with Lenovo's support of Linux on their Legion series laptops. Maybe if enough people chime in, they'll take us seriously and we'll get somewhere. I personally don't need/want formalized Linux support... I just want the hardware to work:
https://forums.lenovo.com/t5/Ubuntu/Ubuntu-and-legion-pro-7-16IRX8H-audio-issues/m-p/5210709

Revision history for this message
In , admin (admin-linux-kernel-bugs) wrote :

On my Legion Slim 7 Gen 7 16ARHA7 Same issue on Debian 12 Testing on Kernel 6.1.0-7
if this is a kernel issue, i hope it gets fixed soon and the distro maintainers can patch this sooner rather than later. Heres my audio info dump:

root@Lavavex-Legion:~# aplay --list-devices
**** List of PLAYBACK Hardware Devices ****
card 1: HDMI [HDA ATI HDMI], device 3: HDMI 0 [HDMI 0]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: HDMI [HDA ATI HDMI], device 7: HDMI 1 [HDMI 1]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 2: Generic [HD-Audio Generic], device 3: HDMI 0 [HDMI 0]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 3: Generic_1 [HD-Audio Generic], device 0: ALC287 Analog [ALC287 Analog]
  Subdevices: 1/1
  Subdevice #0: subdevice #0

root@Lavavex-Legion:~# ls /dev/snd -al
total 0
drwxr-xr-x 3 root root 360 Apr 10 22:23 .
drwxr-xr-x 19 root root 3800 Apr 10 22:23 ..
drwxr-xr-x 2 root root 120 Apr 10 22:23 by-path
crw-rw----+ 1 root audio 116, 3 Apr 10 22:23 controlC0
crw-rw----+ 1 root audio 116, 9 Apr 10 22:23 controlC1
crw-rw----+ 1 root audio 116, 10 Apr 10 22:23 controlC2
crw-rw----+ 1 root audio 116, 14 Apr 10 22:23 controlC3
crw-rw----+ 1 root audio 116, 6 Apr 10 22:23 hwC1D0
crw-rw----+ 1 root audio 116, 8 Apr 10 22:23 hwC2D0
crw-rw----+ 1 root audio 116, 13 Apr 10 22:23 hwC3D0
crw-rw----+ 1 root audio 116, 2 Apr 10 22:23 pcmC0D0c
crw-rw----+ 1 root audio 116, 4 Apr 10 22:23 pcmC1D3p
crw-rw----+ 1 root audio 116, 5 Apr 10 22:23 pcmC1D7p
crw-rw----+ 1 root audio 116, 7 Apr 10 22:23 pcmC2D3p
crw-rw----+ 1 root audio 116, 12 Apr 10 22:23 pcmC3D0c
crw-rw----+ 1 root audio 116, 11 Apr 10 22:31 pcmC3D0p
crw-rw----+ 1 root audio 116, 1 Apr 10 22:23 seq
crw-rw----+ 1 root audio 116, 33 Apr 10 22:23 timer

root@Lavavex-Legion:~# cat /proc/asound/pcm
00-00: DMIC capture dmic-hifi-0 : : capture 1
01-03: HDMI 0 : HDMI 0 : playback 1
01-07: HDMI 1 : HDMI 1 : playback 1
02-03: HDMI 0 : HDMI 0 : playback 1
03-00: ALC287 Analog : ALC287 Analog : playback 1 : capture 1

root@Lavavex-Legion:~# cat /proc/asound/cards
 0 [acp6x ]: acp6x - acp6x
                      LENOVO-82UG-LegionS716ARHA7-LNVNB161216
 1 [HDMI ]: HDA-Intel - HDA ATI HDMI
                      HDA ATI HDMI at 0xc0b00000 irq 79
 2 [Generic ]: HDA-Intel - HD-Audio Generic
                      HD-Audio Generic at 0xc06c8000 irq 80
 3 [Generic_1 ]: HDA-Intel - HD-Audio Generic
                      HD-Audio Generic at 0xc06c0000 irq 81

Revision history for this message
In , aedando (aedando-linux-kernel-bugs) wrote :

(In reply to admin from comment #756)
> On my Legion Slim 7 Gen 7 16ARHA7 Same issue on Debian 12 Testing on Kernel
> 6.1.0-7
> if this is a kernel issue, i hope it gets fixed soon and the distro
> maintainers can patch this sooner rather than later. Heres my audio info
> dump:
>
>
> root@Lavavex-Legion:~# aplay --list-devices
> **** List of PLAYBACK Hardware Devices ****
> card 1: HDMI [HDA ATI HDMI], device 3: HDMI 0 [HDMI 0]
> Subdevices: 1/1
> Subdevice #0: subdevice #0
> card 1: HDMI [HDA ATI HDMI], device 7: HDMI 1 [HDMI 1]
> Subdevices: 1/1
> Subdevice #0: subdevice #0
> card 2: Generic [HD-Audio Generic], device 3: HDMI 0 [HDMI 0]
> Subdevices: 1/1
> Subdevice #0: subdevice #0
> card 3: Generic_1 [HD-Audio Generic], device 0: ALC287 Analog [ALC287 Analog]
> Subdevices: 1/1
> Subdevice #0: subdevice #0
>
> root@Lavavex-Legion:~# ls /dev/snd -al
> total 0
> drwxr-xr-x 3 root root 360 Apr 10 22:23 .
> drwxr-xr-x 19 root root 3800 Apr 10 22:23 ..
> drwxr-xr-x 2 root root 120 Apr 10 22:23 by-path
> crw-rw----+ 1 root audio 116, 3 Apr 10 22:23 controlC0
> crw-rw----+ 1 root audio 116, 9 Apr 10 22:23 controlC1
> crw-rw----+ 1 root audio 116, 10 Apr 10 22:23 controlC2
> crw-rw----+ 1 root audio 116, 14 Apr 10 22:23 controlC3
> crw-rw----+ 1 root audio 116, 6 Apr 10 22:23 hwC1D0
> crw-rw----+ 1 root audio 116, 8 Apr 10 22:23 hwC2D0
> crw-rw----+ 1 root audio 116, 13 Apr 10 22:23 hwC3D0
> crw-rw----+ 1 root audio 116, 2 Apr 10 22:23 pcmC0D0c
> crw-rw----+ 1 root audio 116, 4 Apr 10 22:23 pcmC1D3p
> crw-rw----+ 1 root audio 116, 5 Apr 10 22:23 pcmC1D7p
> crw-rw----+ 1 root audio 116, 7 Apr 10 22:23 pcmC2D3p
> crw-rw----+ 1 root audio 116, 12 Apr 10 22:23 pcmC3D0c
> crw-rw----+ 1 root audio 116, 11 Apr 10 22:31 pcmC3D0p
> crw-rw----+ 1 root audio 116, 1 Apr 10 22:23 seq
> crw-rw----+ 1 root audio 116, 33 Apr 10 22:23 timer
>
> root@Lavavex-Legion:~# cat /proc/asound/pcm
> 00-00: DMIC capture dmic-hifi-0 : : capture 1
> 01-03: HDMI 0 : HDMI 0 : playback 1
> 01-07: HDMI 1 : HDMI 1 : playback 1
> 02-03: HDMI 0 : HDMI 0 : playback 1
> 03-00: ALC287 Analog : ALC287 Analog : playback 1 : capture 1
>
> root@Lavavex-Legion:~# cat /proc/asound/cards
> 0 [acp6x ]: acp6x - acp6x
> LENOVO-82UG-LegionS716ARHA7-LNVNB161216
> 1 [HDMI ]: HDA-Intel - HDA ATI HDMI
> HDA ATI HDMI at 0xc0b00000 irq 79
> 2 [Generic ]: HDA-Intel - HD-Audio Generic
> HD-Audio Generic at 0xc06c8000 irq 80
> 3 [Generic_1 ]: HDA-Intel - HD-Audio Generic
> HD-Audio Generic at 0xc06c0000 irq 81

I have the same laptop model (Legion Slim 7 Gen 7 16ARHA7) and I have the same issue and audio info dump, posting a reply to let the world know I have the same issue.

It's a really great laptop that works amazing with the newer kernels, except for this one thing! Sound even works when connected to 3.5mm or a USB sound device. It's just the built-in speakers.

Revision history for this message
In , stevea12345 (stevea12345-linux-kernel-bugs) wrote :

My Yoga 9 14IAP7 was working well since post #733 above. However I recently booted from kernel kernel-6.2.8-200.fc37.x86_64 to 6.2.14-200.fc37.x86_64 and I get no sound.

Revision history for this message
In , stevea12345 (stevea12345-linux-kernel-bugs) wrote :

Please ignore Comment 758. alsaunmute solved the issue, and was (oddly) only required once.

Revision history for this message
In , li012589li (li012589li-linux-kernel-bugs) wrote :

Hi, I have a thinkbook 16p Gen4 using archlinux with 6.3.1 kernel. The sound only works on 2 out of the 4 speakers (No bass, low volume). Accoding to https://psref.lenovo.com/Product/ThinkBook/ThinkBook_16p_G4_IRH, the audio chip is ACL3306-CG. I wonder if this is the same chip as the ACL3306, or it will require another driver? Also, I wonder if my problem is caused by the audio chip or the smart amplifier?

Revision history for this message
In , thomas.gfeller+kernel (thomas.gfeller+kernel-linux-kernel-bugs) wrote :

Created attachment 304265
journalctl on a 83BU Yoga Pro 9 14IRP8

Revision history for this message
In , thomas.gfeller+kernel (thomas.gfeller+kernel-linux-kernel-bugs) wrote :

(In reply to Thomas Gfeller from comment #761)
> Created attachment 304265 [details]
> journalctl on a 83BU Yoga Pro 9 14IRP8

I have the same issue on a 83BU Yoga Pro 9 14IRP8. I can see some lines that look suspicious in the logs:

skl_hda_dsp_generic skl_hda_dsp_generic: ASoC: Parent card not yet available, widget card binding deferred

I'm running Fedora 38 with 6.2.15-300.fc38.x86_64.

Revision history for this message
Alexis CUGLIETTA (acuglietta) wrote :

I have the same problem with a ThinkBook 13x Gen 2 with Ubuntu 23.04. The sound works properly when connecting external speakers or headset, but I couldn't get the internal speakers to work :( This laptop also has an ALC287/3306 chip with a CS35L41/CSC3551 amplifier. This seems very similar what is mentioned here:

https://gist.github.com/lamperez/862763881c0e1c812392b5574727f6ff?permalink_comment_id=4526397

journalctl displays the following message: "Error: ACPI _DSD Properties are missing for HID CSC3551".

I tried it with the base kernel (6.2.0) as well as the latest one (6.3.3). The issue occurs regarless of the BIOS version (factory version: HXCN49WW and 20230517 version: HXCN52WW).

I used the ACPICA tools to extract the ACPI tables and noticed the entries relative to the CSC3551 did not contain the required "cirrus" and "dev-index" parameters.

This is quite disapointing and I will juste return the laptop to Lenovo.

Revision history for this message
In , alexis.cuglietta (alexis.cuglietta-linux-kernel-bugs) wrote :

I do have exactly the same issue on a ThinkBook 13x Gen 2 running Ubuntu 23.04 (kernels 6.2.0 and 6.3.3): no sound from the internal speakers, although sound works when using the external 3.5mm jack. The laptop has the same chips: ALC287/3306 codec and CS35L41/CSC3551 amplifier.

journalctl displays the following message:
"Error: ACPI _DSD Properties are missing for HID CSC3551"

I have extracted the DST tables using ACPICA and did not see any reference to the 2 parameters required by the CS35L41 driver: "cirrus" and "dev-index".

My conclusion is there is probably some work required from the Lenovo BIOS team :(

Revision history for this message
In , dober (dober-linux-kernel-bugs) wrote :

Created attachment 304296
attachment-15426-0.html

I am currently out of the office on holiday I will be returning on Tuesday May 30, I will be checking email perodically but expect a delay for response.

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Alas, you are correct. The good news is that this is being worked on for
the Legion... But it seems to be for the latest model of the Legion
(which does haven't Cirrus Logic, it has TI smart amps IIRC). I have the
2nd to latest (which I think came out less than a year ago).

Hopefully from there they can work on my model... And perhaps Lenovo can
begin to branch out from there.

It's really too early to guess where things will go, but I'm hopeful.

On 5/20/23 5:01 PM, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> Alexis Cuglietta (<email address hidden>) changed:
>
> What |Removed |Added
> ----------------------------------------------------------------------------
> CC| |<email address hidden>
>
> --- Comment #763 from Alexis Cuglietta (<email address hidden>) ---
> I do have exactly the same issue on a ThinkBook 13x Gen 2 running Ubuntu
> 23.04
> (kernels 6.2.0 and 6.3.3): no sound from the internal speakers, although
> sound
> works when using the external 3.5mm jack. The laptop has the same chips:
> ALC287/3306 codec and CS35L41/CSC3551 amplifier.
>
> journalctl displays the following message:
> "Error: ACPI _DSD Properties are missing for HID CSC3551"
>
> I have extracted the DST tables using ACPICA and did not see any reference to
> the 2 parameters required by the CS35L41 driver: "cirrus" and "dev-index".
>
> My conclusion is there is probably some work required from the Lenovo BIOS
> team
> :(
>

Revision history for this message
In , thomas.gfeller+kernel (thomas.gfeller+kernel-linux-kernel-bugs) wrote :

(In reply to Cameron Berkenpas from comment #765)
> Alas, you are correct. The good news is that this is being worked on for
> the Legion... But it seems to be for the latest model of the Legion
> (which does haven't Cirrus Logic, it has TI smart amps IIRC). I have the
> 2nd to latest (which I think came out less than a year ago).
>
> Hopefully from there they can work on my model... And perhaps Lenovo can
> begin to branch out from there.
>
> It's really too early to guess where things will go, but I'm hopeful.
>
>
> On 5/20/23 5:01 PM, <email address hidden> wrote:
> > https://bugzilla.kernel.org/show_bug.cgi?id=208555
> >
> > Alexis Cuglietta (<email address hidden>) changed:
> >
> > What |Removed |Added
> >
> ----------------------------------------------------------------------------
> > CC|
> |<email address hidden>
> >
> > --- Comment #763 from Alexis Cuglietta (<email address hidden>) ---
> > I do have exactly the same issue on a ThinkBook 13x Gen 2 running Ubuntu
> > 23.04
> > (kernels 6.2.0 and 6.3.3): no sound from the internal speakers, although
> > sound
> > works when using the external 3.5mm jack. The laptop has the same chips:
> > ALC287/3306 codec and CS35L41/CSC3551 amplifier.
> >
> > journalctl displays the following message:
> > "Error: ACPI _DSD Properties are missing for HID CSC3551"
> >
> > I have extracted the DST tables using ACPICA and did not see any reference
> to
> > the 2 parameters required by the CS35L41 driver: "cirrus" and "dev-index".
> >
> > My conclusion is there is probably some work required from the Lenovo BIOS
> > team
> > :(
> >

I just found https://superuser.com/questions/1719920/no-sound-from-internal-speakers-on-laptop-but-headphone-jack-and-hdmi-works with the link https://gist.github.com/lamperez/862763881c0e1c812392b5574727f6ff

It sounds very much like this problem right here. Can we build a workaround for our machines? Extracting the respective data from Windows and injecting it into our Linux istallations?

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

I haven't been able to get this working properly. I was able to get
sound with this approach a few months ago, but I was getting "AMP short"
errors, which I'm sure can't be good.

On 6/5/23 06:45, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> --- Comment #766 from Thomas Gfeller (<email address hidden>) ---
> (In reply to Cameron Berkenpas from comment #765)
>> Alas, you are correct. The good news is that this is being worked on for
>> the Legion... But it seems to be for the latest model of the Legion
>> (which does haven't Cirrus Logic, it has TI smart amps IIRC). I have the
>> 2nd to latest (which I think came out less than a year ago).
>>
>> Hopefully from there they can work on my model... And perhaps Lenovo can
>> begin to branch out from there.
>>
>> It's really too early to guess where things will go, but I'm hopeful.
>>
>>
>> On 5/20/23 5:01 PM, <email address hidden> wrote:
>>> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>>>
>>> Alexis Cuglietta (<email address hidden>) changed:
>>>
>>> What |Removed |Added
>>>
>> ----------------------------------------------------------------------------
>>> CC|
>> |<email address hidden>
>>> --- Comment #763 from Alexis Cuglietta (<email address hidden>) ---
>>> I do have exactly the same issue on a ThinkBook 13x Gen 2 running Ubuntu
>>> 23.04
>>> (kernels 6.2.0 and 6.3.3): no sound from the internal speakers, although
>>> sound
>>> works when using the external 3.5mm jack. The laptop has the same chips:
>>> ALC287/3306 codec and CS35L41/CSC3551 amplifier.
>>>
>>> journalctl displays the following message:
>>> "Error: ACPI _DSD Properties are missing for HID CSC3551"
>>>
>>> I have extracted the DST tables using ACPICA and did not see any reference
>> to
>>> the 2 parameters required by the CS35L41 driver: "cirrus" and "dev-index".
>>>
>>> My conclusion is there is probably some work required from the Lenovo BIOS
>>> team
>>> :(
>>>
> I just found
>
> https://superuser.com/questions/1719920/no-sound-from-internal-speakers-on-laptop-but-headphone-jack-and-hdmi-works
> with the link
> https://gist.github.com/lamperez/862763881c0e1c812392b5574727f6ff
>
> It sounds very much like this problem right here. Can we build a workaround
> for
> our machines? Extracting the respective data from Windows and injecting it
> into
> our Linux istallations?
>

Revision history for this message
In , chrisemke (chrisemke-linux-kernel-bugs) wrote :

Hello guys, have you seen this?
https://forums.lenovo.com/topic/findpost/2713/5210709/6004369?random=nZpbsgdmR0RbJdDLI7lLW8H0NabNneIv_1e738b0f207dd4082957db2fd078d035
Apparently there was some progress on the lenovo forum, they marked it as a solution so I decided to send the link here. I hope it helps

Revision history for this message
In , antidense (antidense-linux-kernel-bugs) wrote :

I have the Legion S7 16ARHA7 w/ Cirrus amp. I've been patching the kernel using lenovo-7i-gen7-sound-6.2.0-rc3-0.0.5b-002.patch with working sound. However, I'm not able to hibernate my laptop successfully. It will hang after saving to disk but it won't shut off on it's own - just stays on with a black screen with the fan going. Then it drains the battery until it dies. If I turn it on again, it will successfully resume from hibernation. I'm not sure what is causing it. It works find if nothing is open (just gnome-shell), but as soon as I open firefox or chrome the problem recurs if it goes to hibernate. Did anyone else have the same issue?

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

This is probably the same as an Nvidia driver issue that I've had... Or
similar... I had the same issue with the Gen 6, and gave up hibernating
completely with the gen7/8.

I could hibernate & resume 1-2 times, and then when resuming... the
laptop would hang, eventually my desktop session would crash and I'd get
the login screen. When not using the Nvidia GPU at all, it worked
consistently.

This is the error I'd see in dmesg:
[   14.045062] nvidia 0000:01:00.0: PM: failed to quiesce async: error -

Seems you can't even shutdown... I don't remember if I encountered that
problem.

Try uninstalling the Nvidia drivers or blacklisting the nvidia module
and see if it still occurs.

On 7/12/23 16:24, <email address hidden> wrote:
> https://bugzilla.kernel.org/show_bug.cgi?id=208555
>
> --- Comment #769 from <email address hidden> ---
> I have the Legion S7 16ARHA7 w/ Cirrus amp. I've been patching the kernel
> using
> lenovo-7i-gen7-sound-6.2.0-rc3-0.0.5b-002.patch with working sound. However,
> I'm not able to hibernate my laptop successfully. It will hang after saving
> to
> disk but it won't shut off on it's own - just stays on with a black screen
> with
> the fan going. Then it drains the battery until it dies. If I turn it on
> again,
> it will successfully resume from hibernation. I'm not sure what is causing
> it.
> It works find if nothing is open (just gnome-shell), but as soon as I open
> firefox or chrome the problem recurs if it goes to hibernate. Did anyone else
> have the same issue?
>

Revision history for this message
In , antidense (antidense-linux-kernel-bugs) wrote :

Thank you for the info. I have AMD graphics, but might still be the same issue.

When I look at the dmesg I only see mt7921e errors. I tried unloading the wifi driver but it didn't make a difference.

Revision history for this message
In , dlinuigh (dlinuigh-linux-kernel-bugs) wrote :

(In reply to antidense from comment #769)
> I have the Legion S7 16ARHA7 w/ Cirrus amp. I've been patching the kernel
> using lenovo-7i-gen7-sound-6.2.0-rc3-0.0.5b-002.patch with working sound.
> However, I'm not able to hibernate my laptop successfully. It will hang
> after saving to disk but it won't shut off on it's own - just stays on with
> a black screen with the fan going. Then it drains the battery until it dies.
> If I turn it on again, it will successfully resume from hibernation. I'm not
> sure what is causing it. It works find if nothing is open (just
> gnome-shell), but as soon as I open firefox or chrome the problem recurs if
> it goes to hibernate. Did anyone else have the same issue?

So, this patch can solve the sound problem, right? Enlighten me pls, I would sacrifice everything to hear my laptop.

1 comments hidden view all 800 comments
Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Depends on which laptop you have. It will work if you have the Legion 7i Gen 7, but not for the Gen 8 (but there is work to get the Gen 8 working that will be mainlined).

Share a link to your alsa-info.

(In reply to Linghui Ding from comment #773)

> So, this patch can solve the sound problem, right? Enlighten me pls, I would
> sacrifice everything to hear my laptop.

Revision history for this message
In , dlinuigh (dlinuigh-linux-kernel-bugs) wrote :

(In reply to Cameron Berkenpas from comment #774)
> Depends on which laptop you have. It will work if you have the Legion 7i Gen
> 7, but not for the Gen 8 (but there is work to get the Gen 8 working that
> will be mainlined).
>
> Share a link to your alsa-info.
>
> (In reply to Linghui Ding from comment #773)
>
> > So, this patch can solve the sound problem, right? Enlighten me pls, I
> would
> > sacrifice everything to hear my laptop.

Here is the URL:

http://alsa-project.org/db/?f=1ea099cf4369c1547b45eec8f9fefdc2f7cfd892

Thanks a lot, and do you think kernel 6.5.0 will include a method that would solve this sound problem?

Revision history for this message
In , zacherytapp (zacherytapp-linux-kernel-bugs) wrote :

Is there any update on the AMD model of the Legion 7 Gen 7? My understanding is it's a different device - but curious if progress has been made there?

Revision history for this message
In , cam (cam-linux-kernel-bugs) wrote :

Then sounds like your laptop is supported by my patch:
https://bugzilla.kernel.org/show_bug.cgi?id=216194

This patch will never make it into the kernel. But if you are able to apply the patch and build your own kernel... This will get you sound.

(In reply to Linghui Ding from comment #775)

> Here is the URL:
>
>
> http://alsa-project.org/db/?f=1ea099cf4369c1547b45eec8f9fefdc2f7cfd892
>
>
> Thanks a lot, and do you think kernel 6.5.0 will include a method that would
> solve this sound problem?

Revision history for this message
In , thomas.gfeller+kernel (thomas.gfeller+kernel-linux-kernel-bugs) wrote :

Created attachment 304764
Amps are working on Yoga Pro 9i 2023

I got my amps working. If your device has a TIAS2781 component inside (http://alsa-project.org/db/?f=45447739750ff897cdc20fd0e98d4f2055beebdf <- note line 71), you can try the following:

Install i2ctools first and then run ./2pa-byps.sh with the i2c-bus number where your TIAS2781 is connected. E.g:

sudo ./2pa-byps.sh 0

In my case this enabled my subwoofers and the sound was working properly.

This change will be included in the kernel in the next couple of weeks / months so no workaround will be necessary anymore.

Revision history for this message
In , hyc (hyc-linux-kernel-bugs) wrote :
Download full text (4.4 KiB)

Hi, I searched this thread for relevant Linux 6.2 references but didn't find anything. My AMD Legion 7 Gen6 that was working on 5.17 kernel + patch just got updates to
Linux viola 6.2.0-26-generic #26~22.04.1-Ubuntu SMP PREEMPT_DYNAMIC Thu Jul 13 16:27:29 UTC 2 x86_64 x86_64 x86_64 GNU/Linux

and the speakers aren't working now. I don't see much in the way of ACPI error messages either on bootup. Here's some extract from dmesg:

[ 4.917409] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: Cirrus Logic CS35L41 (35a40), Revision: B2
[ 4.996344] ACPI Warning: \_SB.PCI0.GPP0.PEGP._DSM: Argument #4 type mismatch - Found [Buffer], ACPI requires [Package] (20221020/nsarguments-61)

[ 5.077457] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: DSP1: Firmware version: 3
[ 5.077461] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: DSP1: cirrus/cs35l41-dsp1-spk-prot-17aa3847.wmfw: Fri 09 Oct 2020 13:07:57 W. Europe Daylight Time
[ 5.090052] ideapad_acpi VPC2004:00: DYTC interface is not available

[ 6.846680] i2c_designware AMDI0010:03: controller timed out
[ 6.872224] i2c_designware AMDI0010:03: timeout in disabling adapter
[ 6.872244] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: DSP1: cirrus/cs35l41-dsp1-spk-prot-17aa3847.wmfw.6: Failed to write 18640 bytes at 0 in PM_PACKED: -110
[ 6.872267] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: Cannot Initialize Firmware. Error: -110
[ 6.892883] i2c_designware AMDI0010:03: timeout waiting for bus ready
[ 6.892890] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: DSP1: Failed to read SCRATCH0: -110
[ 6.892893] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.0: Cannot Run Firmware, reverting to dsp bypass...
[ 6.892903] snd_hda_codec_realtek hdaudioC1D0: bound i2c-CLSA0100:00-cs35l41-hda.0 (ops cs35l41_hda_comp_ops [snd_hda_scodec_cs35l41])
[ 6.896626] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: DSP1: Firmware version: 3
[ 6.896629] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: DSP1: cirrus/cs35l41-dsp1-spk-prot-17aa3847.wmfw: Fri 09 Oct 2020 13:07:57 W. Europe Daylight Time
[ 6.916884] i2c_designware AMDI0010:03: timeout waiting for bus ready
[ 6.916890] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: DSP1: cirrus/cs35l41-dsp1-spk-prot-17aa3847.wmfw.1: Failed to write 60 bytes at 0 in XM_PACKED: -110
[ 6.916898] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: Cannot Initialize Firmware. Error: -110
[ 6.937994] i2c_designware AMDI0010:03: timeout waiting for bus ready
[ 6.938000] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: DSP1: Failed to read SCRATCH0: -110
[ 6.938003] cs35l41-hda i2c-CLSA0100:00-cs35l41-hda.1: Cannot Run Firmware, reverting to dsp bypass...
[ 6.938011] snd_hda_codec_realtek hdaudioC1D0: bound i2c-CLSA0100:00-cs35l41-hda.1 (ops cs35l41_hda_comp_ops [snd_hda_scodec_cs35l41])
[ 6.938477] snd_hda_codec_realtek hdaudioC1D0: autoconfig for ALC287: line_outs=1 (0x17/0x0/0x0/0x0/0x0) type:speaker
[ 6.938480] snd_hda_codec_realtek hdaudioC1D0: speaker_outs=0 (0x0/0x0/0x0/0x0/0x0)
[ 6.938483] snd_hda_codec_realtek hdaudioC1D0: hp_outs=1 (0x21/0x0/0x0/0x0/0x0)
[ 6.938485] snd_hda_codec_realtek hdaudioC1D0: mono: mono_out=0x0
[ 6.938486] snd_hda_codec_realtek hdaud...

Read more...

Revision history for this message
In , chrisemke (chrisemke-linux-kernel-bugs) wrote :

Here on my Lenovo Legion 7 Slim the audio never worked and the microphone worked until 6.4, now in 6.5 nothing works anymore. Does anyone know how I can resolve this? I'm a bit of a beginner

Alsa: http://alsa-project.org/db/?f=24e78ce46f588c8a681c092c24e05811a4f42f77
Kernel: 6.5.2-arch1-1

Revision history for this message
In , git (git-linux-kernel-bugs) wrote :

(In reply to Christian G. Semke from comment #780)
> Here on my Lenovo Legion 7 Slim the audio never worked and the microphone
> worked until 6.4, now in 6.5 nothing works anymore. Does anyone know how I
> can resolve this? I'm a bit of a beginner
>
> Alsa: http://alsa-project.org/db/?f=24e78ce46f588c8a681c092c24e05811a4f42f77
> Kernel: 6.5.2-arch1-1

I've submitted this patch which should fix it: https://<email address hidden>/

Revision history for this message
In , greg (greg-linux-kernel-bugs) wrote :

(In reply to August Wikerfors from comment #781)
> (In reply to Christian G. Semke from comment #780)
> > Here on my Lenovo Legion 7 Slim the audio never worked and the microphone
> > worked until 6.4, now in 6.5 nothing works anymore. Does anyone know how I
> > can resolve this? I'm a bit of a beginner
> >
> > Alsa:
> http://alsa-project.org/db/?f=24e78ce46f588c8a681c092c24e05811a4f42f77
> > Kernel: 6.5.2-arch1-1
>
> I've submitted this patch which should fix it:
> https://<email address hidden>/

Looking at the patch this looks like a microphone quirk patch. It does not look like it patches the audio output side of things.

Do you know of a patch or patch submission that is for audio out on the Legion 7 Slim AMD edition (16ARHA7)?

Revision history for this message
In , dober (dober-linux-kernel-bugs) wrote :

Created attachment 305139
attachment-30610-0.html

I am currently out of the office on holiday I will be returning on Tuesday September 26, I will not be checking email.

Revision history for this message
In , git (git-linux-kernel-bugs) wrote :

(In reply to greg from comment #782)
> Looking at the patch this looks like a microphone quirk patch. It does not
> look like it patches the audio output side of things.
Correct, I should have made that more clear.

> Do you know of a patch or patch submission that is for audio out on the
> Legion 7 Slim AMD edition (16ARHA7)?
Unfortunately not.

Displaying first 40 and last 40 comments. View all 800 comments or add a comment.
This report contains Public information  
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.